// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// PutFlagRequest put flag request
//
// swagger:model putFlagRequest
type PutFlagRequest struct {

	// enabled data records will get data logging in the metrics pipeline, for example, kafka.
	DataRecordsEnabled *bool `json:"dataRecordsEnabled,omitempty"`

	// description
	// Min Length: 1
	Description *string `json:"description,omitempty"`

	// enabled
	Enabled *bool `json:"enabled,omitempty"`

	// it will overwrite entityType into evaluation logs if it's not empty
	EntityType *string `json:"entityType,omitempty"`

	// key
	Key *string `json:"key,omitempty"`

	// notes
	Notes *string `json:"notes,omitempty"`
}

// Validate validates this put flag request
func (m *PutFlagRequest) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDescription(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *PutFlagRequest) validateDescription(formats strfmt.Registry) error {
	if swag.IsZero(m.Description) { // not required
		return nil
	}

	if err := validate.MinLength("description", "body", *m.Description, 1); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this put flag request based on context it is used
func (m *PutFlagRequest) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *PutFlagRequest) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *PutFlagRequest) UnmarshalBinary(b []byte) error {
	var res PutFlagRequest
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
